import { FieldConstraintsCollection, Flattened, AdditionalObjectFieldConstraintsCollection } from "./";
export declare function deepAssign<T>(target: T, src: T): T;
export declare function flatten(fields: FieldConstraintsCollection | (FieldConstraintsCollection & AdditionalObjectFieldConstraintsCollection)): Flattened;
export declare function flattenIfNeeded(input: FieldConstraintsCollection | Flattened): Flattened;
export declare function visit<ConvertedType>(fields: Flattened, resolvePrimitive: (variableName: string, toModify: {
    [key: string]: any;
}, type: ConvertedType | string, variableSettings: {
    [key: string]: any;
}, follower?: any) => void, addObject: (variableName: string, toModify: {
    [key: string]: any;
}, childObj: {
    [key: string]: any;
}, variableSettings: {
    [key: string]: any;
}) => void, typeMap?: {
    [key: string]: ConvertedType;
}, follower?: any): {
    [key: string]: any;
};
export declare function deleteEmptyAndUndefined<T>(target: T): any;
export declare const fieldTypesByTypeName: {
    string: StringConstructor;
    number: NumberConstructor;
    boolean: BooleanConstructor;
    date: DateConstructor;
    object: ObjectConstructor;
};
